#include "vgapaint.h"
#include "gadgets.h"
#include "video.h"

void Make3DGadget(struct Rectangle *r,short x,short y,short xs,short ys,char *name) {
	if (!ys) ys=11;
	if (!xs) xs=6*strlen(name)+4;
	if (r) {
		r->x=x;
		r->y=y;
		r->width=xs;
		r->height=ys;
	};
	vd->bar(&vidbm,x,y,xs,ys,ST2);
	vid_draw3d(&vidbm,x,y,x+xs-1,y+ys-1);
	vd->text6(&vidbm,x+((xs-6*strlen(name))>>1),y+2,name,ST0,ST2);
}

void Depress3DGadget(struct BitMap *bm,struct Rectangle *r) {
	mouse_hide();
	vid_inv3d(bm,r->x,r->y,r->x+r->width-1,r->y+r->height-1);
	mouse_show();
}

void Depress3DGadgets(struct BitMap *bm,struct Rectangle *r,long cnt) {
	mouse_hide();
	while(cnt--) {
		vid_inv3d(bm,r->x,r->y,r->x+r->width-1,r->y+r->height-1);
		++r;
	};
	mouse_show();
}

void Release3DGadget(struct BitMap *bm,struct Rectangle *r) {
	mouse_hide();
	vid_draw3d(bm,r->x,r->y,r->x+r->width-1,r->y+r->height-1);
	mouse_show();
}

void Release3DGadgets(struct BitMap *bm,struct Rectangle *r,long cnt) {
	mouse_hide();
	while(cnt--) {
		vid_draw3d(bm,r->x,r->y,r->x+r->width-1,r->y+r->height-1);
		++r;
	};
	mouse_show();
}

void Click3DGadget(struct BitMap *bm,struct Rectangle *r) {
	Depress3DGadget(bm,r);
	mouse_wait_unkey();
	Release3DGadget(bm,r);
}

