#ifndef	VGAPAINT_MENU_H
#define	VGAPAINT_MENU_H

#include <a/types.h>

#include "list.h"

#ifdef VGAPAINT_MENU_C
#define	EXTERN
#define	INIT(x)	=x
#else
#define	EXTERN extern
#define	INIT(x)
#endif

#define	elements(x)	((sizeof x)/(sizeof x[0]))

#define	MN_START	{(void *)-1L,(void *) 0L}
#define	MN_END		{(void *) 0L,(void *)-1L}
#define	MN_INIT		{(void *)-1L,(void *)-1L}
#define	MN_SOLO		{(void *) 0L,(void *) 0L}

#define	MF_DISABLED	(0x00000001L)
#define MF_DEBUG	(0x00000002L)

#define MP_DOWN		(0)
#define MP_RIGHT	(1)
#define MP_LEFT		(2)

struct Menu {
	struct Node	node;
	struct Menu	*first;
	char		*name;
	char		*auxname;
	ulong		flags;
};

EXTERN int choice[9];			/* use 8 menu levels for now */
EXTERN struct Menu *last_choice INIT(NULL);

#ifndef VGAPAINT_MENU_C

extern struct Menu barmenu[],fillmenu[];
extern struct Menu drawmenu[],rangemenu[],linemenu[];

#endif

struct Menu *MenuListIndex(struct Menu *,int);
void	DisplayMenuBar(struct Menu *);
void	PopupMenu(struct Menu *,struct Rectangle *,int);
boolean	menu_toggle(void);
void	menu_choose(struct Menu *,long start,long num,long current);
void	menu_pick(long n1, ...);
struct Menu *menu_item_address(struct Menu *menu,long n1,...);
int	menu_add_to_end(struct Menu *,struct Menu *);
void	menu_set_toggle_option(struct Menu *menu,boolean newstate);

#undef	EXTERN
#undef	INIT

#endif


