;.386 would cause 66 prefixes to appear everywhere
;.data prevents labels & jumps from being used (stupid assembler)

	public	_com_palette_offset
	public	_com_palette_len
	public	_com_picture_len

_DATA16	segment	public use16 'DATA'

startcds	macro	lbl
		public	lbl
		dd	lbl&_end-lbl
lbl		proc	near
		endm

endcds	macro	lbl
lbl		endp
lbl&_end	equ	$
	endm

;/////////////////////////////

	startcds	_com_initialize

	mov	ax,cs
	mov	dx,ax
	mov	ax,0a000h
	mov	es,ax
	mov	ax,0013h
	int	10h
	cld

	mov	si,0			;ugh, but saves space & time
_com_palette_offset	equ	$-2

	mov	dx,03c8h
	mov	cx,0
_com_palette_len	equ	$-2

;*** follow this by palette decompression code

	endcds		_com_initialize

;////////////////////////////

	startcds	_com_initialize2

	mov	dx,0
_com_picture_len	equ	$-2

	xor	di,di

;*** follow this by picture decompression code

	endcds		_com_initialize2

;////////////////////////////////////////////////////////////////////

	startcds	_com_pdecomp_none

	;i'd like to use REP OUTSB but the 8086 can't do it

	xor	ax,ax
	out	dx,al
	inc	dx
pdcn$1:
	lodsb
	out	dx,al
	loop	pdcn$1

	endcds		_com_pdecomp_none

;////////////////////////////

	startcds	_com_pdecomp_6bit

	;6-bit compression packs 4 6-bit words into 3 8-bit words

	xor	ax,ax
	out	dx,al
	inc	dx
	mov	bx,cx

pdc6b$1:
	lodsb			;AX = --------76543210
	mov	ah,al		;AX = 7654321076543210
	and	al,03fh
	out	dx,al		;AX = 76------76------
	lodsb			;AX = 76------fedcba98
	mov	cl,4
	rol	ax,cl		;AX = ----fedcba9876--
	shr	al,1
	shr	al,1		;AX = ----fedc..ba9876
	out	dx,al
	lodsb			;AX = ----fedcnmlkjihg
	shl	ah,cl		;AX = fedc....nmlkjihg
	mov	cl,2
	ror	ax,cl		;AX = hgfedc....nmlkji
	xchg	al,ah		;AX = ..nmlkjihgfedc..
	shr	al,cl		;AX = ..nmlkji..hgfedc
	out	dx,al
	mov	al,ah
	out	dx,al
	dec	bx
	jne	pdc6b$1

	;this code is 0x22 bytes in length, and saves 25% space
	;don't use if palette length is <=0x88 bytes
	

	endcds		_com_pdecomp_6bit

;////////////////////////////////////////////////////////////////////

	startcds	_com_ddecomp_none

	mov	cx,dx
	rep	movsw		;dump the picture

	endcds		_com_ddecomp_none

;/////////////////////////////

	startcds	_com_ddecomp_pcx

	xor	ah,ah
ddcp$1:
	lodsb
	cmp	al,0c0h
	jb	ddcp$2
	sub	al,0c0h
	mov	cx,ax
	lodsb
	rep	stosb
   	jmp	short ddcp$3
ddcp$2:
	stosb
ddcp$3:
	dec	dx		;loop is faster but vulnerable to ZF
	jne	ddcp$1

	endcds		_com_ddecomp_pcx

;////////////////////////////////////////////////////////////////////

	startcds	_com_termin_key

	xor	ax,ax		;wait for a key
	int	16h

	endcds		_com_termin_key

;////////////////////////////////////////////////////////////////////

	startcds	_com_cleanup

	mov	ax,3		;reset to mode 3
	int	10h
	ret			;terminate to DOS

	endcds		_com_cleanup

_DATA16	ends

	end

