	.386
	.model	flat
	.code

;	Frame_Decompress(dest [eax],src [edx],width [ebx],height [ecx] ,bpr [stack])

	public	Frame_Decompress_

Frame_Decompress_:
	push	ebp
	push	esi
	push	edi
	mov	ebp,[esp+16]
	sub	ebp,ebx
	mov	edi,eax
	mov	esi,edx
	mov	edx,ecx
	xor	ecx,ecx
line_loop:
	push	ebx			;save line width
	cmp	byte ptr [esi],80h	;lines that start with 80h are blank
	jz	is_blank
iff_loop:
	mov	al,[esi]		;get next byte
	inc	esi
	or	al,al
	js	iff_run			;81-ff is a run
	mov	cl,al
	inc	cl
	sub	ebx,ecx
	jb	next_line
	rep	movsb
	or	ebx,ebx
	jnz	iff_loop
	jmp	next_line
iff_run:
	mov	cl,al
	mov	al,[esi]
	neg	cl
	inc	esi
	inc	cl
	sub	ebx,ecx
	jb	next_line
	rep	stosb
	or	ebx,ebx
	jnz	iff_loop
	jmp	next_line

is_blank:
	mov	ecx,ebx
	mov	al,[esi+1]
	add	esi,2
	rep	stosb
next_line:
	pop	ebx			;restore line width
	add	edi,ebp			;add line modulo
	dec	edx
	jne	line_loop
	mov	eax,esi			;return new src ptr
	pop	edi
	pop	esi
	pop	ebp
	ret	4

	end

