#include "prepic1.h"

void PP_Plasma1(void) {
	struct StatusBar *sb;

	mouse_hide();
	vd->set(picbm,0);
//	PP_Plasma1_Func(0,0,320,200);

	sb = CreateStatusBar(picbm->height,"Generating Plasma 1...");

	{
		double x,y,xi,yi,v,d;
		double	y_squared,y_plus_1;
		int y_cnt=0;
		uchar *pm1,*pm2;

		xi = 1.0/(picbm->width -1);
		yi = 1.0/(picbm->height-1);

		pm1 = picbm->vm;
		for(y=0.0;y<=1.0;y+=yi) {

			y_squared	= y * y;
			y_plus_1	= y + 1.0;

			pm2=pm1;	pm1 += picbm->bpr;
			for(x=0.0;x<=1.0;x+=xi) {
//				d = (pow(x + y_plus_1,sqrt(x*x+y_squared))+x+y)*100.0;
//				d = (pow(x + y_plus_1,x*x+y_squared)+x+y)*100.0;
//				d = pow(x + y_plus_1,x*x+y_squared)+x+y;
				d = pow(x + y_plus_1,x*x+y_squared);
//				v = d - floor(d);
//				*pm2++ = floor(v*255.99999999);
				*pm2++ = d*25600.0;		// let built-in byte do looping
			}
			ModifyStatusBar(sb,++y_cnt);
			kbhit();
		}
	}

	DestroyStatusBar(sb);

	mouse_show();
	restore_screen();
}

#if 0
void PP_Plasma1_Func(short x,short y,short xs,short ys) {
	short xsh,ysh;
	uchar c,c2;

	if (xs<=0 || ys<=0) return;

	c=(c2=vd->point(picbm,x,y))+(rand() & 7)-3;

	if ((!c || c>128) && c2<128) c--; else if (c<128 && c2>=128) c++;

	vd->bar(picbm,x,y,xs,ys,c);

	xsh=xs>>1;
	ysh=ys>>1;

	if (xs>1 && ys>1) {
		PP_Plasma1_Func(x,y,xsh,ysh);
		PP_Plasma1_Func(x+xsh,y,xs-xsh,ysh);
		PP_Plasma1_Func(x+xsh,y+ysh,xs-xsh,ys-ysh);
		PP_Plasma1_Func(x,y+ysh,xsh,ys-ysh);
	};
}
#endif

//static ushort greypat[]={ 0xAAAA,0x5555,0xAAAA,0x5555 };

void PP_GammaTest(void) {
	long x,cl;
	uchar *c=piccol;

	for(x=0;x<64;x++) {
		cl=(x*85)/21;
		c[  0]=cl;
		c[  1]=cl;
		c[  2]=cl;

		c[192]=cl;
		c[193]=0;
		c[194]=0;

		c[384]=0;
		c[385]=cl;
		c[386]=0;

		c[576]=0;
		c[577]=0;
		c[578]=cl;
		c+=3;
	};

//	vd->bltpattern(picbm,greypat,  0,  0,16,4, 63,  0);
//	vd->bltpattern(picbm,greypat, 80,  0,16,4,127, 64);
//	vd->bltpattern(picbm,greypat,160,  0,16,4,191,128);
//	vd->bltpattern(picbm,greypat,240,  0,16,4,255,192);
//
//	cl=32;
//
//	for(x=0;x<320;x+=80) {
//		vd->bitblt(picbm,x,0,picbm,x+ 16,  0, 16,  4); /* 32x4 */
//		vd->bitblt(picbm,x,0,picbm,x+ 32,  0, 8,  4);  /* 40x4 */
//		vd->bitblt(picbm,x,0,picbm,x+  0,  4, 40,  4); /* 40x8 */
//		vd->bitblt(picbm,x,0,picbm,x    ,  8, 40,  8); /* 40x16 */
//		vd->bitblt(picbm,x,0,picbm,x    , 16, 40, 16); /* 40x32 */
//		vd->bitblt(picbm,x,0,picbm,x    , 32, 40, 32); /* 40x64 */
//		vd->bitblt(picbm,x,0,picbm,x    , 64, 40, 64); /* 40x128 */
//		vd->bitblt(picbm,x,0,picbm,x    ,128, 40, 72); /* 40x200 */
//		vd->bar(picbm,x+40,0,40,200,cl);
//		cl+=64;
//	};

	x=vidbm.width >> 3;
	vid13_grey(picbm,  0,0,x,vidbm.height, 63,  0);
	vd->bar(   picbm,x*1,0,x,vidbm.height,32);
	vid13_grey(picbm,x*2,0,x,vidbm.height,127, 64);
	vd->bar(   picbm,x*3,0,x,vidbm.height,96);
	vid13_grey(picbm,x*4,0,x,vidbm.height,191,128);
	vd->bar(   picbm,x*5,0,x,vidbm.height,160);
	vid13_grey(picbm,x*6,0,x,vidbm.height,255,192);
	vd->bar(   picbm,x*7,0,x,vidbm.height,224);

	repick_colors();
	restore_screen();
}

void PP_GammaTest2(void) {
	short c,c2=0,c3;
	uchar *col=piccol;

	vd->set(picbm,0);
	for (c=0;c<64;c++) {
		vd->bar(picbm,c2,  0,4,50,c2);
		vd->bar(picbm,c2, 50,4,50,c2+1);
		vd->bar(picbm,c2,100,4,50,c2+2);
		vd->bar(picbm,c2,150,4,50,c2+3);
		c2+=4;
		c3=(c*85)/21;
		*col++=c3;
		*col++=0;
		*col++=0;
		*col++=0;
		*col++=c3;
		*col++=0;
		*col++=0;
		*col++=0;
		*col++=c3;
		*col++=c3;
		*col++=c3;
		*col++=c3;
	};

	for(c=0;c<25;c+=2) {
		for(c2=0;c2<4;c2++) {
			qsetl((ulong *)(picmem+320*25+320*50*c2+320*c),0x00FC00FC+0x01010101*c2,64);
			if (c<24) qsetl((ulong *)(picmem+320*25+320*50*c2+320*c+320),0xFC00FC00+0x01010101*c2,64);
		};
	};

/* the expression (uchar)(-(c&1)) gives 0x00 for evens and 0xFF for odds */

	for(c=0;c<64;c++) {
		for(c2=0;c2<3;c2++) {
			vd->bar(picbm,c<<2,c2*50+48,4,2,(uchar)(-(c&1)));
		};
	};

	rectmodified=FALSE;

	repick_colors();
	restore_screen();
}


////////////////////////////////// MAZE GENERATION ///////////////////////////////////////


typedef	char	DirFlags;
typedef	char	Direction;

static DirFlags	UsedNeighbors(coord x,coord y);
static DirFlags	FreeNeighbors(coord x,coord y);
static Direction	ChooseDirection(DirFlags valid);

#define	Left	1
#define	Right	2
#define	Up	4
#define	Down	8

static struct Rectangle2 PPM_Bounds;

void PP_Maze(void) {
	coord x,y,x2,y2;
	DirFlags paths;
	struct StatusBar *sb;

	vd->set(picbm,7);
	vd->plot(picbm,1,1,0);

	PPM_Bounds.x1=1;
	PPM_Bounds.y1=1;
	PPM_Bounds.x2=((picbm->width -3)&0xFFFFFFFE)+1;
	PPM_Bounds.y2=((picbm->height-3)&0xFFFFFFFE)+1;

	sb=CreateStatusBar(PPM_Bounds.y2>>1,"Generating maze...");

	for(y2=1;y2<=PPM_Bounds.y2;y2+=2) {
		for (x2=1;x2<PPM_Bounds.x2;x2+=2) {

			// find a cell that is disconnected

			if (vd->point(picbm,x2,y2) && (paths=UsedNeighbors(x2,y2))) {

				x=x2;	y=y2;

				switch(ChooseDirection(paths)) {
				case Left:	vd->plot(picbm,x-1,y  ,0);	break;
				case Right:	vd->plot(picbm,x+1,y  ,0);	break;
				case Up:	vd->plot(picbm,x  ,y-1,0);	break;
				case Down:	vd->plot(picbm,x  ,y+1,0);	break;
				};

				for(;;) {
					vd->plot(picbm,x,y,0);

					if (paths=FreeNeighbors(x,y)) {
						switch(ChooseDirection(paths)) {
						case Left:	vd->plot(picbm,x-1,y  ,0);	x-=2;	break;
						case Right:	vd->plot(picbm,x+1,y  ,0);    	x+=2;	break;
						case Up:	vd->plot(picbm,x  ,y-1,0);	y-=2;	break;
						case Down:	vd->plot(picbm,x  ,y+1,0);	y+=2;	break;
						};
					} else break;
				};

			};
		};
		ModifyStatusBar(sb,y2>>1);
	};

	DestroyStatusBar(sb);
	restore_screen();
}

static DirFlags	UsedNeighbors(coord x,coord y) {
	DirFlags n=0;

	if (x>PPM_Bounds.x1) if (!vd->point(picbm,x-2,y  )) n+=Left;
	if (x<PPM_Bounds.x2) if (!vd->point(picbm,x+2,y  )) n+=Right;
	if (y>PPM_Bounds.y1) if (!vd->point(picbm,x  ,y-2)) n+=Up;
	if (y<PPM_Bounds.y2) if (!vd->point(picbm,x  ,y+2)) n+=Down;

	return n;
}

static DirFlags	FreeNeighbors(coord x,coord y) {
	DirFlags n=0;

	if (x>PPM_Bounds.x1) if (vd->point(picbm,x-2,y  )) n+=Left;
	if (x<PPM_Bounds.x2) if (vd->point(picbm,x+2,y  )) n+=Right;
	if (y>PPM_Bounds.y1) if (vd->point(picbm,x  ,y-2)) n+=Up;
	if (y<PPM_Bounds.y2) if (vd->point(picbm,x  ,y+2)) n+=Down;

	return n;
}

static Direction	ChooseDirection(DirFlags valid) {
	DirFlags ch;

	if (!(valid&15)) exit(5);

	do { kbhit(); } while(!(valid & (ch=(1<<(rand()&3)))));

	return ch;
}
