#if !defined(A_TYPES_H) && !defined(BRIGHTEYES_TYPES_H)
#define	A_TYPES_H

struct _QuadU {
	unsigned long lo,hi;
};

struct _QuadS {
	unsigned long lo;
	signed long hi;
};

typedef	unsigned char		uchar;
typedef	unsigned short		ushort;
typedef	unsigned long		ulong;
typedef	unsigned int		uint;
typedef	signed char		schar;
typedef	signed short		sshort;
typedef	signed long		slong;
typedef	signed int		sint;
typedef char			boolean;
typedef	unsigned int		flag;
typedef	void			(*vfptr)(void);
typedef	struct _QuadS		quad;
typedef	struct _QuadS		squad;
typedef	struct _QuadU		uquad;

#ifndef	TRUE
#define	TRUE	1
#endif
#ifndef	FALSE
#define	FALSE	0
#endif

#ifndef	NULL
#define	NULL	0
#endif

#define	NEW(x)	((x *)malloc(sizeof(x)))
#define	ANEW(x,y)	((x *)malloc(sizeof(x [y])))

#endif
