	.386
	.model	flat
	.code

	public	ilace8_
	public	vbltime_
	public	setvbltime_
	extern	_oldint8	: near

ilace8_:
	push	edx
	push	eax
	mov	edx,3dah
$1:
	in	al,dx
	test	al,8
	jz	$1

	mov	dl,0d4h
	mov	al,0dh
	out	dx,al
	inc	dl
	in	al,dx
	xor	al,80
	out	dx,al

	mov	al,36h
	out	43h,al
	mov	al,1
ilace8_timer_low	equ	$-1
	out	40h,al
	mov	al,42h
ilace8_timer_high	equ	$-1
	out	40h,al

	mov	al,60h		;clear outstanding IRQ0
	out	20h,al

	pop	eax
	pop	edx

	jmp	cs:fword ptr _oldint8

vbltime_:
	push	edx
	push	ecx
	push	ebx

	cli				;no ints

	in	al,61h
	or	al,1			;gate high
	and	al,0fdh			;speaker low
	out	61h,al

; set speaker for max period, interrupt mode

	mov	al,0B0h			;timer2 msb-then-lsb mode 0 binary
	out	43h,al
	xor	al,al
	out	42h,al
	out	42h,al

	mov	al,80h
	out	43h,al			;latch counter 2 (11)
	in	al,42h
	mov	bl,al
	in	al,42h
	mov	bh,al

	mov	al,80h
	out	43h,al			;latch counter 2 (11)
	in	al,42h
	mov	cl,al
	in	al,42h
	mov	ch,al

	sub	ebx,ecx			;bx = zero time
	mov	edx,3dah		;save time in inner loop

$4:					;loop for VBL
	in	al,dx
	test	al,8
	jz	$4
$2:					;loop for non-VBL
	in	al,dx
	test	al,8
	jnz	$2

	mov	al,80h
	out	43h,al			;latch counter 2 (11)
	in	al,42h
	mov	cl,al
	in	al,42h
	mov	ch,al

$3:					;loop for VBL
	in	al,dx
	test	al,8
	jz	$3
$5:					;loop for non-VBL
	in	al,dx
	test	al,8
	jnz	$5

	mov	al,80h
	out	43h,al			;latch counter 2 (11)
	in	al,42h
	mov	dl,al
	in	al,42h
	mov	dh,al

	sti				;ints

	sub	ecx,edx			;CX = VBL loop time
	sub	ecx,ebx			;subtract empty loop time
	mov	eax,ecx
	and	eax,0000ffffh

	pop	ebx
	pop	ecx
	pop	edx
	ret

setvbltime_:
	sub	eax,256			;this allows ~16k cycles on my 486DX2-80 for resync
	mov	byte ptr ilace8_timer_low,al		;self-modifying code is nasty but fast
	mov	byte ptr ilace8_timer_high,ah
	ret

	end

