#ifndef	VGAPAINT_LIST_H
#define	VGAPAINT_LIST_H

#include <a/types.h>

struct List {
	struct Node *next;
	struct Node *prevnext;
	struct Node *prev;
};

struct Node {
	struct Node *next;
	struct Node *prev;
};

#define	_AddHead(l,n) ((n)->prev=(l)->prev,(n)->next=(struct Node *)&(l)->prevnext,(n)->prev->next=(n),(l)->prev=(n))
#define	_AddTail(l,n) ((n)->next=(l)->next,(n)->prev=(struct Node *)&(l)->next,(n)->next->prev=(n),(l)->next=(n))
#define	_RemHead(l,n) (n=(l)->prev,(n)->prev ? ((l)->prev=(n)->prev,(l)->prev->next=(struct Node *)&(l)->prevnext,(n)) : (n))
#define	_RemTail(l,n) (n=(l)->next,(n)->next ? ((l)->next=(n)->next,(l)->next->prev=(struct Node *)&(l)->next,(n)) : (n))
#define	_Remove(n) ((n)->next->prev=(n)->prev,(n)->prev->next=(n)->next)

void		NewList(struct List *);
void		AddHead(struct List *,struct Node *);
void		AddTail(struct List *,struct Node *);
struct Node *	RemHead(struct List *);
struct Node *	RemTail(struct List *);
void		Remove(struct Node *);
ulong		ListLength(struct List *);
struct		Node **MakeNodeTable(struct List *);
void		DisposeNodeTable(struct Node **);
void		DisposeNodeTableCompletely(struct Node **);
void		DisposeNodesInList(struct List *);

#endif
