#ifndef PARM_H
#define PARM_H

#include <a/types.h>

#ifndef PARM_C
#define EXTERN extern
#define INIT(x)
#else
#define EXTERN
#define INIT(x) =x
#endif

//////////////////////////////////////////////////

struct KeyAliasNode {
	ushort key;
	ulong command;
	ulong arg1;
	ulong arg2;
	ulong arg3;
};

struct ResourceStrings {
	char **table;
	char *buf;
	int count;
};

//////////////////////////////////////////////////

EXTERN struct KeyAliasNode *	key_shortcuts INIT(NULL);
EXTERN long			key_shortcut_count;
EXTERN struct ResourceStrings startup_strings
#ifdef PARM_C
={
	NULL,NULL,0
}
#endif
;

//////////////////////////////////////////////////

char *FindResourceString(struct ResourceStrings *rscs,ulong num);

#undef EXTERN
#undef INIT

#endif

