#ifndef	A_PICLOAD_H
#define A_PICLOAD_H

#include <a/types.h>

#include "list.h"

#define	PCAL_MATCH	(0)
#define	PCAL_FUNCTION	(1)

typedef boolean (*PictureAutoLoaderFunction)(uchar *data,ulong len);
typedef int (*PictureLoader)(char *name);

struct PictureAutoLoader {
	struct Node node;
	char	pri;
	uchar	type;
	ushort	len;
	union {
		void				*match_address;
		PictureAutoLoaderFunction	match_function;
	};
	char	*extension;
	PictureLoader load_function;
};

#endif

