#ifndef	VGAPAINT_VIDEOH_H
#define	VGAPAINT_VIDEOH_H

#include "vgapaint.h"
#include "video.h"

#ifdef	VGAPAINT_VIDEOH_C
#define	EXTERN
#define	INIT(x)	=x
#else
#define	EXTERN	extern
#define	INIT(x)
#endif

EXTERN struct VDevSpecs	vdh_specs
#ifdef	VGAPAINT_VIDEOH_C
={	640,200,640,200,640,200,640,200		}
#endif
;

boolean	vidH_init(enum VD_InitCode vdic,long x,long y);
void	vidH_rhline(coord x,coord y,uchar *dm1,coord xs);
void	vidH_rhlineread(coord x,coord y,uchar *dm1,coord xs);
void	vidH_rbitblt(coord x,coord y,coord xs,coord ys,uchar *dm1,long dmod,boolean no_offset);
void	vidH_drawptr(struct MousePointerInfo *mpi,coord x,coord y);
void	vidH_eraseptr(struct MousePointerInfo *mpi);

EXTERN struct VDev vdh
#ifdef	VGAPAINT_VIDEOH_C
	={
		&vid13_set,
		&vid13_plot,
		&vid13_point,
		&vid13_bar,
		&vid13_bitblt,
		&vid13_bitbltcolor,
		&vid13_bitblttrans,
		&vid13_bitbltswap,
		&vid13_bitbltswaptrans,
		&vid13_bitbltswapmask,
		&vid13_bltpattern,
		&vid13_bltpattern3d,
		&vid_text6,		/* rely on limit text routine */
		&vid13_text6trans,
		&vid13_text6lim,
		&vid13_hline,
		&vid13_vline,
		&vid13_line,
		&vid_box,
		&vid_circle,
		&vid_ellipse,
		&vid_blocksave,
		&vid_blockrestore,
		&vid_hblit,
		&vid_vblit,
		&vid13_tile,
		&vid13_rassize,
		&vid13_bpr,
		&vidH_init,
		&vid_refresh,
		&vidH_rhline,
		&vid13_quickfill,
		&vidH_rbitblt,
		&vidH_drawptr,
		&vidH_eraseptr,
		&vidH_rhlineread
	}
#endif
;

#undef	INIT
#undef	EXTERN

#endif
